# coding: utf-8

import numpy as np
import volonoi
import random
# from PySide.QtGui import QImage, qRgb
from PyQt4.QtGui import QImage, qRgb
from os.path import expanduser

import sys
# from PySide import QtGui
# from PySide import QtCore
from PyQt4 import QtGui
from PyQt4 import QtCore

'''
TCYĂ{^̈ʒuς炸Eɂ悤ɂ.
'''



class NotImplementedException:
    pass

gray_color_table = [qRgb(i, i, i) for i in range(256)]

# http://stackoverflow.com/questions/6671741/python-convert-iplimage-to-qimage
def toQImage(im, copy=False):
    if im is None:
        return QImage()

    if im.dtype == np.uint8:
        if len(im.shape) == 2:
            qim = QImage(im.data, im.shape[1], im.shape[0], im.strides[0], QImage.Format_Indexed8)
            qim.setColorTable(gray_color_table)
            return qim.copy() if copy else qim

        elif len(im.shape) == 3:
            if im.shape[2] == 3:
                qim = QImage(im.data, im.shape[1], im.shape[0], im.strides[0], QImage.Format_RGB888);
                return qim.copy() if copy else qim
            elif im.shape[2] == 4:
                qim = QImage(im.data, im.shape[1], im.shape[0], im.strides[0], QImage.Format_ARGB32);
                return qim.copy() if copy else qim

    raise NotImplementedException

class VolonoiSimulator(QtGui.QWidget):
	def __init__(self):
		super(VolonoiSimulator, self).__init__()
		self.initUI()

	def initUI(self):

		self.is_simulating = False
		self.seed_pos = []
		self.world = None

		self.timer = QtCore.QTimer(parent=self)
		self.timer.setInterval(10) # self.interval Ԃő҂, timertimerout
		self.timer.timeout.connect(self.step_simulation) # timertimeroutVOiɑ΂ do_countdown sȂ.

		self.layout = QtGui.QHBoxLayout() # up_down
		self.menu_layout = QtGui.QVBoxLayout() # Ẽj[
		self.world_layout = QtGui.QGridLayout() # ̃[h

		self.layout.addStretch(1)
		self.menu_layout.addStretch(1)
		# world.addStretch(1)

		self.layout.addLayout(self.world_layout)
		self.layout.addLayout(self.menu_layout)

		# world
		# pixmap = QtGui.QPixmap('./Figures/test.jpg')
		self.world_scale = (400, 400)
		pixmap = QtGui.QPixmap(*self.world_scale)
		pixmap.fill(QtGui.QColor(102,153,204))
		pixmap = pixmap.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)
		self.world_pict = QtGui.QLabel(self)

		self.world_pict.mousePressEvent = self.append_seed
		self.world_pict.setPixmap(pixmap)
		self.world_layout.addWidget(self.world_pict)

		# menu 
		self.world_shape_x_layout = QtGui.QHBoxLayout() # up_down
		self.world_shape_x = QtGui.QLineEdit('50')
		self.world_shape_x_layout.addWidget(QtGui.QLabel('Height'))
		self.world_shape_x_layout.addWidget(self.world_shape_x)

		self.world_shape_y_layout = QtGui.QHBoxLayout() # up_down
		self.world_shape_y = QtGui.QLineEdit('50')
		self.world_shape_y_layout.addWidget(QtGui.QLabel('Width '))
		self.world_shape_y_layout.addWidget(self.world_shape_y)


		self.myMetric = u'L1'
		self.myMetric_layout = QtGui.QHBoxLayout() # up_down
		self.myMetric_combo = QtGui.QComboBox(self)
		self.myMetric_combo.addItem(u'L1')
		self.myMetric_combo.addItem(u'L2')
		self.myMetric_combo.addItem(u'Linf')
		self.myMetric_layout.addWidget(QtGui.QLabel('myMetric'))
		self.myMetric_layout.addWidget(self.myMetric_combo)
		self.myMetric_combo.activated[unicode].connect(self.set_myMetric)
		

		self.radius_layout = QtGui.QHBoxLayout() # up_down
		self.radius_edit = QtGui.QLineEdit('1')
		self.radius_layout.addWidget(QtGui.QLabel('Radius'))
		self.radius_layout.addWidget(self.radius_edit)

		self.btn_layout = QtGui.QVBoxLayout() # up_down
		
		self.exec_btn_layout = QtGui.QVBoxLayout() # up_down
		self.init_btn = QtGui.QPushButton('Random Init.')
		self.init_btn.clicked.connect(self.random_seed_init)
		self.exec_btn_layout.addWidget(self.init_btn)

		self.exec_btn = QtGui.QPushButton('Execute')
		self.exec_btn.clicked.connect(self.exec_simulation)
		self.exec_btn_layout.addWidget(self.exec_btn)

		self.pause_restart_layout = QtGui.QHBoxLayout() # up_down
		self.pause_btn = QtGui.QPushButton('Pause')
		self.pause_btn.clicked.connect(self.pause_simulation)
		self.restart_btn = QtGui.QPushButton('Restart')
		self.restart_btn.clicked.connect(self.restart_simulation)
		self.pause_restart_layout.addWidget(self.pause_btn)
		self.pause_restart_layout.addWidget(self.restart_btn)

		self.clr_btn_layout = QtGui.QVBoxLayout() # up_down
		self.init_btn = QtGui.QPushButton('Clear')
		self.init_btn.clicked.connect(self.clear)
		self.clr_btn_layout.addWidget(self.init_btn)

		self.save_layout = QtGui.QVBoxLayout() # up_down

		self.filename_layout = QtGui.QHBoxLayout()
		self.filename_edit = QtGui.QLineEdit('.png')
		self.filename_layout.addWidget(QtGui.QLabel('File name'))
		self.filename_layout.addWidget(self.filename_edit)
		
		self.save_layout.addLayout(self.filename_layout)

		self.save_btn_layout = QtGui.QHBoxLayout()
		self.save_btn = QtGui.QPushButton('Save')
		self.save_btn.clicked.connect(self.showDialog)
		self.save_btn_layout.addWidget(self.save_btn)

		self.save_layout.addLayout(self.save_btn_layout)		

		self.btn_layout.addLayout(self.exec_btn_layout)
		self.btn_layout.addLayout(self.pause_restart_layout)
		self.btn_layout.addLayout(self.clr_btn_layout)

		self.menu_widgets_layout = [
						self.world_shape_x_layout,
						self.world_shape_y_layout,
						self.radius_layout,
						self.myMetric_layout,
						self.btn_layout,
						self.save_layout
						]

		for l in self.menu_widgets_layout:
			self.menu_layout.addLayout(l)

		self.setLayout(self.layout)
		

		self.move(300, 150)
		self.setWindowTitle('Volonoi Simulator')


		self.show()
		# print 'ӂ'
		# print 'ق'


	def showDialog(self):

		# dirname = QtGui.QFileDialog.getOpenFileName(self, 'Select Directory')
		dirname = QtGui.QFileDialog.getExistingDirectory(
 			self,
    		"Open a folder",
    		expanduser("~"),
    		QtGui.QFileDialog.ShowDirsOnly
		)
		
		if dirname:
			self.save_img(dirname+'/')
			return True
		
		# print 'canceled!!'
		return False

		# f = open(fname, 'r')

		# with f:
			# data = f.read()
			# self.textEdit.setText(data)


	def save_img(self, dirname):

		filename = self.filename_edit.text()

		if not filename:
			print 'Pleased set file name'
			return False

		self.timer.stop()
		qimg = self.world.world_picture()
		arr = np.asarray(qimg)
		qimg = toQImage(arr)
		qimg = qimg.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)

		qimg.save(dirname + filename)
		

	def clear(self):
		self.timer.stop()
		pixmap = QtGui.QPixmap(*self.world_shape)
		pixmap.fill(QtGui.QColor(102,153,204))
		pixmap = pixmap.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)
		self.world_pict.setPixmap(pixmap)

		self.world = None
		self.seed_pos = []

	def set_myMetric(self):
		# print type(self.myMetric_combo.currentText())
		self.myMetric = self.myMetric_combo.currentText()

	def random_seed_init(self):
		if not self.set_parameters():
			return False

		area = self.world_shape[0] * self.world_shape[1]
		N = random.randint(int(area*1.5/500), int(area*2.5/500))

		self.seed_pos=[(random.randint(0, self.world_shape[0]-1), random.randint(0, self.world_shape[1]-1)) for i in xrange(N)] # random.randint͒[_܂

		self.world = volonoi.World(world_shape=self.world_shape, seed_pos=self.seed_pos, radius=self.radius, metric=self.myMetric)
		qimg = self.world.world_picture()
		arr = np.asarray(qimg)
		qimg = toQImage(arr)
		qimg = qimg.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)
		self.world_pict.setPixmap(QtGui.QPixmap.fromImage(qimg))

		return True

	def exec_simulation(self):
		self.is_simulating = True
		if not self.set_parameters():
			return False

		if self.seed_pos == []:
			print 'no seeds are given, random seeds are generated and used'
			self.random_seed_init()

		self.world = volonoi.World(world_shape=self.world_shape, seed_pos=self.seed_pos, radius=self.radius, metric=self.myMetric)

		self.timer.start()

	def pause_simulation(self):
		self.timer.stop()
		self.is_simulating = False

	def restart_simulation(self):
		if self.world is not None:
			self.timer.start()
			self.is_simulating = True

	def step_simulation(self):
		if not self.is_simulating:
			return False

		qimg = self.world.world_picture()
		arr = np.asarray(qimg)
		qimg = toQImage(arr)
		qimg = qimg.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)

		self.world_pict.setPixmap(QtGui.QPixmap.fromImage(qimg))
	
		if not self.world.update_world():
			self.is_simulating = False
			self.timer.stop()

		return True

	def set_parameters(self):
		try:
		    x = int(self.world_shape_x.text())
		    y = int(self.world_shape_y.text())
		    radius = int(self.radius_edit.text())
		except TypeError:
			print 'Please set parameters properly'
			return False

		self.world_shape = (x, y)
		self.radius = radius

		return True

	def append_seed(self , event):
	    w = event.pos().x()
	    h = event.pos().y()

	    if not self.set_parameters():
			return False

	    scaling_h = self.world_shape[0] / (1.0*self.world_scale[0])
	    scaling_w = self.world_shape[0] / (1.0*self.world_scale[0])
	    pos = (int(h * scaling_h), int(w * scaling_w))

	    if pos not in self.seed_pos:
			self.seed_pos.append(pos)
	    else:
			self.seed_pos.remove(pos)

	    self.world = volonoi.World(world_shape=self.world_shape, seed_pos=self.seed_pos, radius=self.radius, metric=self.myMetric)
	    

	    qimg = self.world.world_picture()
	    arr = np.asarray(qimg)
	    qimg = toQImage(arr)
	    qimg = qimg.scaled(self.world_scale[0], self.world_scale[1], QtCore.Qt.KeepAspectRatio)
	    self.world_pict.setPixmap(QtGui.QPixmap.fromImage(qimg))


def main():

	app = QtGui.QApplication(sys.argv)
	ex = VolonoiSimulator()
	sys.exit(app.exec_())

if __name__ == '__main__':
	main()
