# coding: utf-8
# http://www.hundredsoft.jp/win7blog/log/eid119.html

# import numpy as np

def condition1(ninecell, nonemptySymbols=[]):
    pixList = [ninecell[0][1], ninecell[0][2], ninecell[1][2], ninecell[2][2], ninecell[2][1], ninecell[2][0], ninecell[1][0], ninecell[0][0]]
    total = 0
    for i in xrange(len(pixList)):
        if (pixList[i] in nonemptySymbols) and (pixList[(i+1) % len(pixList)] not in nonemptySymbols):
            total += 1

    return total == 1

def condition2(ninecell, nonemptySymbols=[]):
    pixList = [ninecell[0][1], ninecell[0][2], ninecell[1][2], ninecell[2][2], ninecell[2][1], ninecell[2][0], ninecell[1][0], ninecell[0][0]]
    total = sum([1 for x in pixList if x in nonemptySymbols[:len(nonemptySymbols)]])
    
    return 2 <= total and total <= 6
    
def condition3(ninecell, nonemptySymbols=[], mode=1):
    assert(mode == 1 or mode == 2)

    pixList = [ninecell[0][1], ninecell[0][2], ninecell[1][2], ninecell[2][2], ninecell[2][1], ninecell[2][0], ninecell[1][0], ninecell[0][0]]
    
    for i in xrange(len(pixList)):
        if pixList[i] in nonemptySymbols:
            pixList[i] = 1
        else:
            pixList[i] = 0

    if mode == 1:
        # P2 x P4 x P6 = 0 AP4 x P6 x P8 = 0 𖞂B
        return pixList[0]*pixList[2]*pixList[4] == 0 and pixList[2]*pixList[4]*pixList[6] == 0
    else:
        # P2 x P4 x P8 = 0 AP2 x P6 x P8 = 0 𖞂
        assert(mode == 2)
        return pixList[0]*pixList[2]*pixList[6] == 0 and pixList[0]*pixList[4]*pixList[6] == 0
    
def check_condition(ninecell, nonemptySymbols=[], mode=1):
    # print ninecell
    # pixList = [ninecell[0][1], ninecell[0][2], ninecell[1][2], ninecell[2][2], ninecell[2][1], ninecell[2][0], ninecell[1][0], ninecell[0][0], ninecell[0][1]]
    # print pixList
    return condition1(ninecell, nonemptySymbols=nonemptySymbols) and condition2(ninecell, nonemptySymbols=nonemptySymbols) and condition3(ninecell, nonemptySymbols=nonemptySymbols, mode=mode)

def print_ninecell(world, center):
    print world[center[0]-1][center[1]-1].label, world[center[0]-1][center[1]].label, world[center[0]-1][center[1]+1].label
    print world[center[0]][center[1]-1].label, world[center[0]][center[1]].label, world[center[0]][center[1]+1].label
    print world[center[0]+1][center[1]-1].label, world[center[0]+1][center[1]].label, world[center[0]+1][center[1]+1].label

def thinning(world, nonemptySymbols, emptySymbols):
    assert(len(nonemptySymbols) == 1) # ̂Ƃ. 
    assert(len(emptySymbols) == 1) # ̂Ƃ. 

    h, w = (len(world), len(world[0]))
    mode = 1

    while(True):
        delList = []
        for i in xrange(1, h-1):
            for j in xrange(1, w-1):
                ninecell = [[world[i-1][j-1].label, world[i-1][j].label, world[i-1][j+1].label], 
                            [world[i][j-1].label, world[i][j].label, world[i][j+1].label], 
                            [world[i+1][j-1].label, world[i+1][j].label, world[i+1][j+1].label]
                            ]
                
                if (world[i][j].label in nonemptySymbols) and check_condition(ninecell, nonemptySymbols=nonemptySymbols, mode=mode):
                    # print_ninecell(world, (i, j))
                    # print "True (", i, ', ', j, ')\n'
                    delList.append([i, j])

        if delList == []:
            break

        for pos in delList:
            world[pos[0]][pos[1]].set_label(emptySymbols[0]) # len(emptySymbols) > 1 ̎͂ǂIԂ߂ȂƂȂ

        mode = int(mode != 2) + 1 # 1 <-> 2 ̌JԂ

    return world

